# From https://gist.github.com/gaurav712/42549678b778db12fda5764f7c0757ad

#################################
#
# Backend
#
#################################

# Backend to use: "xrender" or "glx".
# GLX backend is typically much faster but depends on a sane driver.
backend = "xrender"

#################################
#
# GLX backend
#
#################################

glx-no-stencil = true

# GLX backend: Copy unmodified regions from front buffer instead of redrawing them all.
# My tests with nvidia-drivers show a 10% decrease in performance when the whole screen is modified,
# but a 20% increase when only 1/4 is.
# My tests on nouveau show terrible slowdown.
glx-copy-from-front = false

# GLX backend: Use MESA_copy_sub_buffer to do partial screen update.
# My tests on nouveau shows a 200% performance boost when only 1/4 of the screen is updated.
# May break VSync and is not available on some drivers.
# Overrides --glx-copy-from-front.
# glx-use-copysubbuffermesa = true;

# GLX backend: Avoid rebinding pixmap on window damage.
# Probably could improve performance on rapid window content changes, but is known to break things on some drivers (LLVMpipe).
# Recommended if it works.
# glx-no-rebind-pixmap = true;

# GLX backend: GLX buffer swap method we assume.
# Could be undefined (0), copy (1), exchange (2), 3-6, or buffer-age (-1).
# undefined is the slowest and the safest, and the default value.
# copy is fastest, but may fail on some drivers,
# 2-6 are gradually slower but safer (6 is still faster than 0).
# Usually, double buffer means 2, triple buffer means 3.
# buffer-age means auto-detect using GLX_EXT_buffer_age, supported by some drivers.
# Useless with --glx-use-copysubbuffermesa.
# Partially breaks --resize-damage.
# Defaults to undefined.
#glx-swap-method = "undefined";

#################################
#
# Opacity
#
#################################

inactive-opacity = 1
active-opacity = 1
frame-opacity = 1
inactive-opacity-override = false

opacity-rule = [
	# terminal (Alacritty)
	"100:class_g = 'Alacritty' && focused",
	"85:class_g = 'Alacritty' && !focused",

	# Flashfocus
	"0:_NET_WM_STATE@:32a *= '_NET_WM_STATE_HIDDEN'"
]

#################################
#
# Rounded corners
#
#################################

corner-radius = 10
round-borders = 1
rounded-corners-exclude = [
	"class_g = 'i3bar'",
	"class_g = 'i3-frame'",
	"class_g = 'code-oss'",
]

#################################
#
# Fading
#
#################################

# Fade windows during opacity changes.
fading = true
# The time between steps in a fade in milliseconds. (default 10).
fade-delta = 7
# Opacity change between steps while fading in. (default 0.028).
fade-in-step = 0.03
# Opacity change between steps while fading out. (default 0.03).
fade-out-step = 0.03
# Fade windows in/out when opening/closing
# no-fading-openclose = true;

# Specify a list of conditions of windows that should not be faded.
fade-exclude = [
	# "class_g = 'Alacritty'",
]

#################################
#
# Other
#
#################################

# Try to detect WM windows and mark them as active.
mark-wmwin-focused = true
# Mark all non-WM but override-redirect windows active (e.g. menus).
mark-ovredir-focused = true
# Use EWMH _NET_WM_ACTIVE_WINDOW to determine which window is focused instead of using FocusIn/Out events.
# Usually more reliable but depends on a EWMH-compliant WM.
use-ewmh-active-win = true
# Detect rounded corners and treat them as rectangular when --shadow-ignore-shaped is on.
detect-rounded-corners = true

# Detect _NET_WM_OPACITY on client windows, useful for window managers not passing _NET_WM_OPACITY of client windows to frame windows.
# This prevents opacity being ignored for some apps.
# For example without this enabled my xfce4-notifyd is 100% opacity no matter what.
detect-client-opacity = true

# Vertical synchronization: match the refresh rate of the monitor
vsync = true

# Enable DBE painting mode, intended to use with VSync to (hopefully) eliminate tearing.
# Reported to have no effect, though.
dbe = true

# Limit picom to repaint at most once every 1 / refresh_rate second to boost performance.
# This should not be used with --vsync drm/opengl/opengl-oml as they essentially does --sw-opti's job already,
# unless you wish to specify a lower refresh rate than the actual value.
#sw-opti = true;

# Unredirect all windows if a full-screen opaque window is detected, to maximize performance for full-screen windows, like games.
# Known to cause flickering when redirecting/unredirecting windows.
unredir-if-possible = true

# Specify a list of conditions of windows that should always be considered focused.
focus-exclude = [
	"class_g = 'i3'",
	"override_redirect",
]

# Use WM_TRANSIENT_FOR to group windows, and consider windows in the same group focused at the same time.
detect-transient = true
# Use WM_CLIENT_LEADER to group windows, and consider windows in the same group focused at the same time.
# WM_TRANSIENT_FOR has higher priority if --detect-transient is enabled, too.
detect-client-leader = true

#################################
#
# Window type settings
#
#################################

wintypes:
{
	tooltip =
	{
		# fade: Fade the particular type of windows.
		fade = true
		# shadow: Give those windows shadow
		shadow = true
		# opacity: Default opacity for the type of windows.
		opacity = 0.85
		# focus: Whether to always consider windows of this type focused.
		focus = true
	}
}

######################
#
# XSync
# See: https://github.com/yshui/picom/commit/b18d46bcbdc35a3b5620d817dd46fbc76485c20d
#
######################

# Use X Sync fence to sync clients' draw calls. Needed on nvidia-drivers with GLX backend for some users.
xrender-sync-fence = true
